]> git.proxmox.com Git - grub2.git/blob - debian/postinst.in
Add 'debian/grub-extras/' from commit 'f2a079441939eee7251bf141986cdd78946e1d20'
[grub2.git] / debian / postinst.in
1 #!/bin/bash
2 set -e
3
4 merge_debconf_into_conf()
5 {
6 local tmpfile; tmpfile="$1"
7 local setting; setting="$2"
8 local template; template="$3"
9
10 db_get "$template"
11 local value; value="$(echo "$RET" | sed -e 's,[$`"\],\\&,g')"
12 if grep -q "^${setting}=" "$tmpfile"; then
13 value="$(echo "$value" | sed -e 's,[\@],\\&,g')"
14 sed -i -re "s@^(${setting}=).*@\1\"${value}\"@" "$tmpfile"
15 else
16 echo >> "$tmpfile"
17 echo "${setting}=\"${value}\"" >> "$tmpfile"
18 fi
19 }
20
21 get_wubi_device()
22 {
23 if [ ! -x /usr/share/lupin-support/grub-mkimage ] || \
24 ! /usr/share/lupin-support/grub-mkimage --test; then
25 return 1
26 fi
27
28 local bootdev="$(grub-probe --target=device /boot)" || true
29 local loop_file=
30 case $bootdev in
31 /dev/loop/*|/dev/loop[0-9])
32 loop_file="$(losetup "$bootdev" | sed -e "s/^[^(]*(\([^)]\+\)).*/\1/")"
33 # If it's loop-mounted from another device, it isn't Wubi.
34 case $loop_file in
35 /dev/*) return 1 ;;
36 esac
37 ;;
38 *) return 1 ;;
39 esac
40
41 echo "$bootdev"
42 }
43
44 # This only works on a Linux system with udev running. This is probably the
45 # vast majority of systems where we need any of this, though, and we fall
46 # back reasonably gracefully if we don't have it.
47 cached_available_ids=
48 available_ids()
49 {
50 local id path
51
52 if [ "$cached_available_ids" ]; then
53 echo "$cached_available_ids"
54 return
55 fi
56
57 [ -d /dev/disk/by-id ] || return
58 cached_available_ids="$(
59 for path in /dev/disk/by-id/*; do
60 [ -e "$path" ] || continue
61 printf '%s %s\n' "$path" "$(readlink -f "$path")"
62 done | sort -k2 -s -u | cut -d' ' -f1
63 )"
64 echo "$cached_available_ids"
65 }
66
67 # Returns non-zero and no output if no mapping can be found.
68 device_to_id()
69 {
70 local id
71 for id in $(available_ids); do
72 if [ "$(readlink -f "$id")" = "$(readlink -f "$1")" ]; then
73 echo "$id"
74 return 0
75 fi
76 done
77 # Fall back to the plain device name if there's no by-id link for it.
78 if [ -e "$1" ]; then
79 echo "$1"
80 return 0
81 fi
82 return 1
83 }
84
85 devices_to_ids()
86 {
87 local device id ids
88 ids=
89 for device; do
90 id="$(device_to_id "$device" || true)"
91 if [ "$id" ]; then
92 ids="${ids:+$ids, }$id"
93 fi
94 done
95 echo "$ids"
96 }
97
98 all_disks()
99 {
100 local id
101 for id in $(available_ids); do
102 case $id in
103 *-part*) ;;
104 *) echo "$id" ;;
105 esac
106 done
107 }
108
109 all_partitions()
110 {
111 local id ids
112 ids=
113 for id in $(available_ids); do
114 if [ "$id" != "$1" ] && [ "${id%-part*}" = "$1" ]; then
115 ids="${ids:+$ids }$id"
116 fi
117 done
118 echo "$ids"
119 }
120
121 # In order to determine whether we accidentally ran grub-install without
122 # upgrade-from-grub-legacy on versions older than 1.98+20100617-1, we need
123 # to be able to scan a disk to determine whether GRUB 2 was installed in its
124 # boot sector. This is specific to i386-pc (but that's the only platform
125 # where we need it).
126 scan_grub2()
127 {
128 if ! dd if="$1" bs=512 count=1 2>/dev/null | grep -aq GRUB; then
129 # No version of GRUB is installed.
130 return 1
131 fi
132
133 # The GRUB boot sector always starts with a JMP instruction.
134 initial_jmp="$(dd if="$1" bs=2 count=1 2>/dev/null | od -Ax -tx1 | \
135 head -n1 | cut -d' ' -f2,3)"
136 [ "$initial_jmp" ] || return 1
137 initial_jmp_opcode="${initial_jmp%% *}"
138 [ "$initial_jmp_opcode" = eb ] || return 1
139 initial_jmp_operand="${initial_jmp#* }"
140 case $initial_jmp_operand in
141 47|4b|4c|63)
142 # I believe this covers all versions of GRUB 2 up to the package
143 # version where we gained a more explicit mechanism. GRUB Legacy
144 # always had 48 here.
145 return 0
146 ;;
147 esac
148
149 return 1
150 }
151
152 # for Linux
153 sysfs_size()
154 {
155 local num_sectors sector_size size
156 # Try to find out the size without relying on a partitioning tool being
157 # installed. This isn't too hard on Linux 2.6 with sysfs, but we have to
158 # try a couple of variants on detection of the sector size.
159 if [ -e "$1/size" ]; then
160 num_sectors="$(cat "$1/size")"
161 sector_size=512
162 if [ -e "$1/queue/logical_block_size" ]; then
163 sector_size="$(cat "$1/queue/logical_block_size")"
164 elif [ -e "$1/queue/hw_sector_size" ]; then
165 sector_size="$(cat "$1/queue/hw_sector_size")"
166 fi
167 size="$(expr "$num_sectors" \* "$sector_size" / 1000 / 1000)"
168 fi
169 [ "$size" ] || size='???'
170 echo "$size"
171 }
172
173 # for kFreeBSD
174 camcontrol_size()
175 {
176 local num_sectors sector_size size=
177
178 if num_sectors="$(camcontrol readcap "$1" -q -s -N)"; then
179 sector_size="$(camcontrol readcap "$1" -q -b)"
180 size="$(expr "$num_sectors" \* "$sector_size" / 1000 / 1000)"
181 fi
182
183 [ "$size" ] || size='???'
184 echo "$size"
185 }
186
187 # Returns value in $RET, like a debconf command.
188 describe_disk()
189 {
190 local disk id base size
191 disk="$1"
192 id="$2"
193
194 model=
195 case $(uname -s) in
196 Linux)
197 if which udevadm >/dev/null 2>&1; then
198 size="$(sysfs_size "/sys$(udevadm info -n "$disk" -q path)")"
199 else
200 base="${disk#/dev/}"
201 base="$(printf %s "$base" | sed 's,/,!,g')"
202 size="$(sysfs_size "/sys/block/$base")"
203 fi
204
205 if which udevadm >/dev/null 2>&1; then
206 model="$(udevadm info -n "$disk" -q property | sed -n 's/^ID_MODEL=//p')"
207 if [ -z "$model" ]; then
208 model="$(udevadm info -n "$disk" -q property | sed -n 's/^DM_NAME=//p')"
209 if [ -z "$model" ]; then
210 model="$(udevadm info -n "$disk" -q property | sed -n 's/^MD_NAME=//p')"
211 if [ -z "$model" ] && which dmsetup >/dev/null 2>&1; then
212 model="$(dmsetup info -c --noheadings -o name "$disk" 2>/dev/null || true)"
213 fi
214 fi
215 fi
216 fi
217 ;;
218 GNU/kFreeBSD)
219 disk_basename=$(basename "$disk")
220 size="$(camcontrol_size "$disk_basename")"
221 model="$(camcontrol inquiry "$disk_basename" | sed -ne "s/^pass0: <\([^>]*\)>.*/\1/p")"
222 ;;
223 esac
224
225 [ "$model" ] || model='???'
226
227 db_subst grub-pc/disk_description DEVICE "$disk"
228 db_subst grub-pc/disk_description SIZE "$size"
229 db_subst grub-pc/disk_description MODEL "$model"
230 db_metaget grub-pc/disk_description description
231 }
232
233 # Returns value in $RET, like a debconf command.
234 describe_partition()
235 {
236 local disk part id path diskbase partbase size
237 disk="$1"
238 part="$2"
239 id="$3"
240 path="$4"
241
242 if which udevadm >/dev/null 2>&1; then
243 size="$(sysfs_size "/sys$(udevadm info -n "$part" -q path)")"
244 else
245 diskbase="${disk#/dev/}"
246 diskbase="$(printf %s "$diskbase" | sed 's,/,!,g')"
247 partbase="${part#/dev/}"
248 partbase="$(printf %s "$partbase" | sed 's,/,!,g')"
249 size="$(sysfs_size "/sys/block/$diskbase/$partbase")"
250 fi
251
252 db_subst grub-pc/partition_description DEVICE "$part"
253 db_subst grub-pc/partition_description SIZE "$size"
254 db_subst grub-pc/partition_description PATH "$path"
255 db_metaget grub-pc/partition_description description
256 }
257
258 usable_partitions()
259 {
260 local last_partition path partition partition_id
261
262 last_partition=
263 for path in / /boot /boot/grub; do
264 partition="$(grub-probe -t device "$path" || true)"
265 if [ -z "$partition" ] || [ "$partition" = "$last_partition" ]; then
266 continue
267 fi
268 partition_id="$(device_to_id "$partition" || true)"
269 echo "$path:$partition_id"
270 last_partition="$partition"
271 done | sort -t: -k2
272 }
273
274 get_mountpoint()
275 {
276 local relpath boot_mountpoint
277
278 relpath="$(grub-mkrelpath "$1")"
279 boot_mountpoint="${1#$relpath}"
280 echo "${boot_mountpoint:-/}"
281 }
282
283 config_item()
284 {
285 for x in /etc/default/grub /etc/default/grub.d/*.cfg; do
286 if [ -e "$x" ]; then
287 . "$x"
288 fi
289 done
290 if [ "$(eval echo "\${$1+set}")" = set ]; then
291 eval echo "\$$1"
292 else
293 return
294 fi
295 }
296
297 running_in_container()
298 {
299 type systemd-detect-virt >/dev/null 2>&1 && systemd-detect-virt --quiet --container
300 }
301
302 no_nvram_arg() {
303 db_get grub2/update_nvram
304 if [ "$RET" = false ]; then
305 echo "--no-nvram"
306 fi
307 }
308
309 run_grub_install()
310 {
311 if ! grub-install $@ ; then
312 echo "Failed: grub-install $@" >&2
313 echo "WARNING: Bootloader is not properly installed, system may not be bootable" >&2
314 fi
315 }
316
317 case "$1" in
318 configure)
319 . /usr/share/debconf/confmodule
320
321 devicemap_regenerated=
322
323 if egrep -q '^[[:space:]]*post(inst|rm)_hook[[:space:]]*=[[:space:]]*(/sbin/|/usr/sbin/)?update-grub' /etc/kernel-img.conf 2>/dev/null; then
324 echo 'Removing update-grub hooks from /etc/kernel-img.conf in favour of' >&2
325 echo '/etc/kernel/ hooks.' >&2
326 sed -ri /etc/kernel-img.conf -e '\%^[[:space:]]*post(inst|rm)_hook[[:space:]]*=[[:space:]]*(/sbin/|/usr/sbin/)?update-grub%d'
327 fi
328
329 mkdir -p /boot/grub
330
331 case @PACKAGE@ in
332 grub-pc)
333 if test -e /boot/grub/device.map && ! test -e /boot/grub/core.img && \
334 ! test -e /boot/grub/@FIRST_CPU_PLATFORM@/core.img; then
335 # Looks like your device.map was generated by GRUB Legacy, which
336 # used to generate broken device.map (see #422851). Avoid the risk
337 # by regenerating it.
338 grub-mkdevicemap --no-floppy
339 devicemap_regenerated=1
340 fi
341 ;;
342 esac
343
344 if test -z "$devicemap_regenerated" && test -s /boot/grub/device.map && \
345 dpkg --compare-versions "$2" lt-nl 1.98+20100702-1 && \
346 test "$(uname -s)" = Linux; then
347 # Earlier versions of GRUB used unstable device names in device.map,
348 # which caused a variety of problems. There is some risk associated with
349 # regenerating it (so we prompt the user if it's non-trivial), but on the
350 # whole it's less risky to move to /dev/disk/by-id/.
351 devicemap_lines="$(egrep -v '^[[:space:]]+#' /boot/grub/device.map | wc -l)"
352 grub-mkdevicemap --no-floppy
353 devicemap_regenerated=1
354 if test "$devicemap_lines" != 1; then
355 db_input critical grub2/device_map_regenerated || true
356 db_go || true
357 fi
358 fi
359
360 if test -z "$devicemap_regenerated" && \
361 dpkg --compare-versions "$2" lt-nl 1.99~20101210-2 && \
362 grep -qs /md-uuid- /boot/grub/device.map; then
363 echo "Removing MD devices from device.map, since the BIOS cannot read from these." >&2
364 sed -i '/\/md-uuid-/d' /boot/grub/device.map
365 fi
366
367 tmp_default_grub="$(mktemp -t grub.XXXXXXXXXX)"
368 trap "rm -f ${tmp_default_grub}" EXIT
369 cp -p /usr/share/grub/default/grub ${tmp_default_grub}
370
371 merge_debconf_into_conf "$tmp_default_grub" GRUB_CMDLINE_LINUX grub2/linux_cmdline
372 merge_debconf_into_conf "$tmp_default_grub" GRUB_CMDLINE_LINUX_DEFAULT grub2/linux_cmdline_default
373
374 case @PACKAGE@ in
375 grub-pc)
376 merge_debconf_into_conf "$tmp_default_grub" GRUB_TIMEOUT grub-pc/timeout
377 sed -i -e 's/^\(GRUB_TIMEOUT=\)"\([0-9][0-9]*\)"/\1\2/' "$tmp_default_grub"
378 db_get grub-pc/hidden_timeout
379 if [ "$RET" = false ]; then
380 sed -i -e 's/^GRUB_HIDDEN_TIMEOUT=/#&/' "$tmp_default_grub"
381 fi
382 ;;
383 esac
384
385 ucf --three-way --debconf-ok --sum-file=/usr/share/grub/default/grub.md5sum ${tmp_default_grub} /etc/default/grub
386 package="$(ucfq --with-colons /etc/default/grub | cut -d : -f 2)"
387 if echo $package | grep -q "^grub-" ; then
388 ucfr --force @PACKAGE@ /etc/default/grub
389 else
390 ucfr @PACKAGE@ /etc/default/grub
391 fi
392
393 case @PACKAGE@ in
394 grub-pc)
395
396 fix_mixed_system=
397 if test -e /boot/grub/stage2 && test -e /boot/grub/menu.lst && \
398 ! test -e /boot/grub/grub2-installed && \
399 test -z "$UPGRADE_FROM_GRUB_LEGACY"; then
400 # Unfortunately, it's still possible that the user upgraded fully
401 # to GRUB 2 in some way other than running
402 # upgrade-from-grub-legacy; perhaps they ran grub-install by hand
403 # for some reason. It's really quite difficult to detect this
404 # situation, because the only difference between this and a
405 # working chainloaded setup is that in this case grub-setup has
406 # been run. So, to try to tell the difference, we scan the boot
407 # sectors of all disks for a GRUB 2 boot sector. Hopefully this
408 # won't cause too much to explode, since I can't think of a better
409 # method.
410 grub2_disks=
411 for disk in $(all_disks); do
412 if scan_grub2 "$disk"; then
413 grub2_disks="${grub2_disks:+$grub2_disks }$(readlink -f "$disk")"
414 fi
415 done
416 if [ "$grub2_disks" ]; then
417 # No || true here; it's vital that the user sees this, and it's
418 # better to throw an error than to do the wrong thing.
419 db_subst grub-pc/mixed_legacy_and_grub2 DISKS "$grub2_disks"
420 db_fset grub-pc/mixed_legacy_and_grub2 seen false
421 db_input critical grub-pc/mixed_legacy_and_grub2
422 db_go
423 db_get grub-pc/mixed_legacy_and_grub2
424 if [ "$RET" = true ]; then
425 db_reset grub-pc/install_devices
426 UPGRADE_FROM_GRUB_LEGACY=1
427 fix_mixed_system=1
428 # Fall through to normal installation logic.
429 fi
430 fi
431 fi
432
433 # Make sure that Wubi users never see confusing device prompts.
434 # Wubi is a very specialised hack that does complicated things with
435 # grub-install diversions to create an image that's chained from the
436 # Windows boot loader to boot an operating system from a file on a
437 # Windows file system. In these circumstances, prompting for where
438 # to install GRUB is not going to help anyone.
439 wubi_device="$(get_wubi_device)" || true
440 if [ "$wubi_device" ]; then
441 db_set grub-pc/install_devices "$wubi_device"
442 db_fset grub-pc/install_devices seen true
443 fi
444
445 if test -e /boot/grub/stage2 && test -e /boot/grub/menu.lst && \
446 ! test -e /boot/grub/grub2-installed && \
447 test -z "$UPGRADE_FROM_GRUB_LEGACY"; then
448 db_get grub-pc/chainload_from_menu.lst
449 if $RET ; then
450 # Create core.img (but do not risk writing to MBR).
451 # Using grub-probe instead of "(hd0)" avoids (UUID=) hack slowness
452 # in case /boot/grub is not on (hd0) in device.map.
453 echo "Generating core.img" >&2
454 grub-install --target=i386-pc --no-floppy --grub-setup=/bin/true "$(grub-probe -t drive /boot/grub)" > /dev/null
455
456 # Update menu.lst to reflect that:
457 # - core.img is present now
458 # - core.img has to be the first option
459 echo "Saving menu.lst backup in /boot/grub/menu.lst_backup_by_grub2_postinst" >&2
460 cp /boot/grub/menu.lst{,_backup_by_grub2_postinst}
461 echo "Running update-grub Legacy to hook our core.img in it" >&2
462 LET_US_TRY_GRUB_2=true /usr/lib/grub-legacy/update-grub 2>&1 | sed -e "s/^/ /g" >&2
463 # We just hooked GRUB 2 in menu.lst; then also generate grub.cfg.
464 touch /boot/grub/grub.cfg
465 fi
466 elif running_in_container; then
467 # Skip grub-install in containers.
468 :
469 elif test -z "$2" || test -e /boot/grub/core.img || \
470 test -e /boot/grub/@FIRST_CPU_PLATFORM@/core.img || \
471 test "$UPGRADE_FROM_GRUB_LEGACY" || test "$wubi_device"; then
472 question=grub-pc/install_devices
473 priority=high
474 device_map="$(grub-mkdevicemap -m - | grep -v '^(fd[0-9]\+)' || true)"
475 devices="$(echo "$device_map" | cut -f2)"
476 if dpkg --compare-versions "$2" lt 1.98+20100702-1 && \
477 test "$(uname -s)" = Linux && [ -z "$wubi_device" ]; then
478 # Migrate to new by-id naming scheme.
479 db_get grub-pc/install_devices
480 old_devices="$(echo "$RET" | sed 's/, / /g')"
481 new_devices=
482 # Common-case optimisation: if the list of devices is
483 # identical to the LHS of grub-mkdevicemap's output, then
484 # there's no point asking again; just install to all disks.
485 # (This handles e.g. "(hd0)" with one disk.)
486 if [ "$(echo "$device_map" | cut -f1 | sort)" = \
487 "$(echo "$old_devices" | xargs -n1 | sort)" ]; then
488 new_devices="$(devices_to_ids $devices)"
489 db_set grub-pc/install_devices "$new_devices"
490 # Alternatively, we might be installing to a single partition
491 # on a single disk, and we can deal with that too if there's
492 # only one available disk and it has an appropriate partition.
493 # This doesn't necessarily work for multiple disks because now
494 # the order matters.
495 elif [ "$(echo "$device_map" | wc -l)" = 1 ] && \
496 [ "$(echo "$old_devices" | wc -w)" = 1 ] && \
497 echo "$old_devices" | grep -q ,; then
498 old_device="${old_devices#(}"
499 old_device="${old_device%)}"
500 old_disk="${old_device%,*}"
501 old_partition="${old_device##*,}"
502 new_device="$(echo "$device_map" | grep "^($old_disk)" | \
503 cut -f2)"
504 new_device="$(device_to_id $new_device)"
505 if [ "$new_device" ]; then
506 new_device="$new_device-part$old_partition"
507 # Run through device_to_id again to check for existence.
508 new_device="$(device_to_id $new_device)"
509 fi
510 if [ "$new_device" ]; then
511 new_devices="$new_device"
512 db_set grub-pc/install_devices "$new_device"
513 fi
514 fi
515 if [ -z "$new_devices" ]; then
516 new_devices="$(devices_to_ids $old_devices)"
517 db_set grub-pc/install_devices "$new_devices"
518 # Common-case optimisation: if all devices are translatable
519 # to by-id and the number of devices there is the same as
520 # the number of devices GRUB can see, then there's no point
521 # asking again. (This handles e.g. "/dev/sda" with one
522 # disk.)
523 old_devices_count="$(echo "$old_devices" | wc -w)"
524 new_devices_count="$(echo "$new_devices" | wc -w)"
525 devices_count="$(echo "$devices" | wc -w)"
526 if [ "$old_devices_count" != "$new_devices_count" ] || \
527 [ "$new_devices_count" != "$devices_count" ]; then
528 db_fset grub-pc/install_devices seen false
529 db_fset grub-pc/install_devices_empty seen false
530 fi
531 fi
532 else
533 db_get grub-pc/install_devices
534 valid=1
535 for device in $RET; do
536 if [ ! -e "${device%,}" ]; then
537 valid=0
538 break
539 fi
540 done
541 if [ "$valid" = 0 ]; then
542 question=grub-pc/install_devices_disks_changed
543 priority=critical
544 db_set "$question" "$RET"
545 db_fset "$question" seen false
546 db_fset grub-pc/install_devices_empty seen false
547 fi
548 fi
549
550 while :; do
551 ids=
552 descriptions=
553 partitions="$(usable_partitions)"
554 for device in $devices; do
555 disk_id="$(device_to_id "$device" || true)"
556 if [ "$disk_id" ]; then
557 ids="${ids:+$ids, }$disk_id"
558 describe_disk "$(readlink -f "$device")" "$disk_id"
559 RET="$(printf %s "$RET" | sed 's/,/\\,/g')"
560 descriptions="${descriptions:+$descriptions, }$RET"
561 for partition_pair in $partitions; do
562 partition_id="${partition_pair#*:}"
563 if [ "${partition_id#$disk_id-part}" != "$partition_id" ]; then
564 ids="${ids:+$ids, }$partition_id"
565 describe_partition "$(readlink -f "$device")" "$(readlink -f "$partition_id")" "$partition_id" "$(get_mountpoint "${partition_pair%%:*}")"
566 RET="$(printf %s "$RET" | sed 's/,/\\,/g')"
567 descriptions="${descriptions:+$descriptions, }$RET"
568 fi
569 done
570 fi
571 done
572 # Some "partitions" may in fact be at the disk level, e.g. RAID.
573 # List these as well if they haven't already been listed.
574 for partition_pair in $partitions; do
575 partition_id="${partition_pair#*:}"
576 if [ "${partition_id#*-part}" = "$partition_id" ]; then
577 case ", $ids, " in
578 ", $partition_id, ") ;;
579 *)
580 ids="${ids:+$ids, }$partition_id"
581 describe_disk "$(readlink -f "$partition_id")" "$partition_id"
582 RET="$(printf %s "$RET" | sed 's/,/\\,/g')"
583 descriptions="${descriptions:+$descriptions, }$RET"
584 ;;
585 esac
586 fi
587 done
588 db_subst "$question" RAW_CHOICES "$ids"
589 db_subst "$question" CHOICES "$descriptions"
590 db_input "$priority" "$question" || true
591 db_go
592 db_get "$question"
593 failed_devices=
594 for i in `echo $RET | sed -e 's/, / /g'` ; do
595 real_device="$(readlink -f "$i")"
596 if grub-install --target=i386-pc --force --no-floppy $real_device ; then
597 # We just installed GRUB 2; then also generate grub.cfg.
598 touch /boot/grub/grub.cfg
599 else
600 failed_devices="$failed_devices $real_device"
601 fi
602 done
603
604 if [ "$question" != grub-pc/install_devices ]; then
605 db_set grub-pc/install_devices "$RET"
606 db_fset grub-pc/install_devices seen true
607 fi
608
609 if [ "$failed_devices" ]; then
610 if [ "$UPGRADE_FROM_GRUB_LEGACY" ]; then
611 db_subst grub-pc/install_devices_failed_upgrade FAILED_DEVICES "$failed_devices"
612 db_fset grub-pc/install_devices_failed_upgrade seen false
613 if db_input critical grub-pc/install_devices_failed_upgrade; then
614 db_go
615 db_get grub-pc/install_devices_failed_upgrade
616 if [ "$RET" = true ]; then
617 db_fset "$question" seen false
618 db_fset grub-pc/install_devices_failed_upgrade seen false
619 continue
620 else
621 exit 1
622 fi
623 else
624 exit 1 # noninteractive
625 fi
626 else
627 db_subst grub-pc/install_devices_failed FAILED_DEVICES "$failed_devices"
628 db_fset grub-pc/install_devices_failed seen false
629 if db_input critical grub-pc/install_devices_failed; then
630 db_go
631 db_get grub-pc/install_devices_failed
632 if [ "$RET" = true ]; then
633 break
634 else
635 db_fset "$question" seen false
636 db_fset grub-pc/install_devices_failed seen false
637 continue
638 fi
639 else
640 break # noninteractive
641 fi
642 fi
643 fi
644
645 db_get grub-pc/install_devices
646 if [ -z "$RET" ]; then
647 # Reset the seen flag if the current answer is false, since
648 # otherwise we'll loop with no indication of why.
649 db_get grub-pc/install_devices_empty
650 if [ "$RET" = false ]; then
651 db_fset grub-pc/install_devices_empty seen false
652 fi
653 if db_input critical grub-pc/install_devices_empty; then
654 db_go
655 db_get grub-pc/install_devices_empty
656 if [ "$RET" = true ]; then
657 break
658 else
659 db_fset "$question" seen false
660 db_fset grub-pc/install_devices_empty seen false
661 fi
662 else
663 break # noninteractive
664 fi
665 else
666 break
667 fi
668 done
669 fi
670
671 # /boot/grub/ has more chances of being accessible by GRUB
672 for i in /usr/share/grub/unicode.pf2 ; do
673 if test -e $i ; then
674 cp $i /boot/grub/
675 fi
676 done
677
678 if [ "$fix_mixed_system" ]; then
679 # These never contain any valuable information, and they aren't
680 # useful for boot any more, since we just overwrote MBR/PBR.
681 rm -f /boot/grub/{{xfs,reiserfs,e2fs,fat,jfs,minix}_stage1_5,stage{1,2}}
682 # Remove marker file used to indicate that grub-install was run
683 # rather than upgrade-from-grub-legacy. Since stage2 has been
684 # removed, we don't need this any more.
685 rm -f /boot/grub/grub2-installed
686 fi
687 ;;
688
689 grub-efi-ia32|grub-efi-amd64|grub-efi-ia64|grub-efi-arm|grub-efi-arm64)
690 bootloader_id="$(config_item GRUB_DISTRIBUTOR | tr A-Z a-z | \
691 cut -d' ' -f1)"
692 case $bootloader_id in
693 kubuntu) bootloader_id=ubuntu ;;
694 esac
695 if [ "$bootloader_id" ] && [ -d "/boot/efi/EFI/$bootloader_id" ]; then
696 case @PACKAGE@ in
697 grub-efi-ia32) target=i386-efi ;;
698 grub-efi-amd64) target=x86_64-efi ;;
699 grub-efi-ia64) target=ia64-efi ;;
700 grub-efi-arm) target=arm-efi ;;
701 grub-efi-arm64) target=arm64-efi ;;
702 esac
703 db_get grub2/force_efi_extra_removable
704 if [ "$RET" = true ]; then
705 FORCE_EXTRA_REMOVABLE="--force-extra-removable"
706 fi
707 NO_NVRAM="$(no_nvram_arg)"
708 run_grub_install --target="$target" "$FORCE_EXTRA_REMOVABLE" "$NO_NVRAM"
709 fi
710
711 # /boot/grub/ has more chances of being accessible by GRUB
712 for i in /usr/share/grub/unicode.pf2 ; do
713 if test -e $i ; then
714 cp $i /boot/grub/
715 fi
716 done
717
718 if type update-secureboot-policy >/dev/null 2>&1; then
719 update-secureboot-policy || true
720 fi
721 ;;
722
723 grub-ieee1275)
724 case $(dpkg --print-architecture) in
725 powerpc|ppc64|ppc64el)
726 # Output may be empty; if so, just update the core image but
727 # don't install it to any PReP partition.
728 prep_bootdev="$(/usr/lib/grub/powerpc-ieee1275/prep-bootdev)"
729 NO_NVRAM="$(no_nvram_arg)"
730 run_grub_install --target=powerpc-ieee1275 $prep_bootdev "$NO_NVRAM"
731 ;;
732 esac
733 ;;
734
735 grub-yeeloong)
736 run_grub_install --target=mipsel-loongson
737 ;;
738
739 grub-xen)
740 # Install for x86_64 regardless of arch, since a 32-bit userspace can still boot with a 64-bit kernel.
741 mkdir -p /boot/xen
742 run_grub_install --target=x86_64-xen
743 case $(dpkg --print-architecture) in
744 i386)
745 run_grub_install --target=i386-xen
746 ;;
747 esac
748 ;;
749 esac
750
751 # If grub.cfg has been generated, update it.
752 if test -e /boot/grub/grub.cfg && ! running_in_container; then
753 update-grub 3>&-
754 fi
755 ;;
756 abort-upgrade|abort-remove|abort-deconfigure)
757 ;;
758 *)
759 echo "postinst called with unknown argument \`$1'" >&2
760 exit 1
761 ;;
762 esac
763
764 # dh_installdeb will replace this with shell code automatically
765 # generated by other debhelper scripts.
766
767 #DEBHELPER#
768
769 exit 0